Index: serefpolicy-contrib-20140730/postfix.te
===================================================================
--- serefpolicy-contrib-20140730.orig/postfix.te
+++ serefpolicy-contrib-20140730/postfix.te
@@ -775,31 +714,100 @@ optional_policy(`
 	sasl_connect(postfix_smtpd_t)
 ')
 
-optional_policy(`
-	spamassassin_read_spamd_pid_files(postfix_smtpd_t)
-	spamassassin_stream_connect_spamd(postfix_smtpd_t)
-')
-
 ########################################
 #
-# Virtual local policy
+# Postfix virtual local policy
 #
 
-allow postfix_virtual_t self:process setrlimit;
+allow postfix_virtual_t self:process { setsched setrlimit };
 
-allow postfix_virtual_t postfix_spool_t:file rw_file_perms;
+manage_files_pattern(postfix_virtual_t, postfix_spool_t, postfix_spool_t)
 
+# connect to master process
 stream_connect_pattern(postfix_virtual_t, { postfix_private_t postfix_public_t }, { postfix_private_t postfix_public_t }, postfix_master_t)
 
+corecmd_exec_shell(postfix_virtual_t)
 corecmd_exec_bin(postfix_virtual_t)
 
-mta_read_aliases(postfix_virtual_t)
 mta_delete_spool(postfix_virtual_t)
-mta_read_config(postfix_virtual_t)
 mta_manage_spool(postfix_virtual_t)
 
 userdom_manage_user_home_dirs(postfix_virtual_t)
-userdom_manage_user_home_content_dirs(postfix_virtual_t)
-userdom_manage_user_home_content_files(postfix_virtual_t)
-userdom_home_filetrans_user_home_dir(postfix_virtual_t)
-userdom_user_home_dir_filetrans_user_home_content(postfix_virtual_t, { file dir })
+userdom_manage_user_home_content(postfix_virtual_t)
+userdom_filetrans_home_content(postfix_virtual_t)
+
+########################################
+#
+# postfix_domain common policy
+#
+allow postfix_domain self:capability { sys_nice sys_chroot };
+dontaudit postfix_domain self:capability sys_tty_config;
+allow postfix_domain self:process { signal_perms setpgid setsched };
+allow postfix_domain self:unix_dgram_socket create_socket_perms;
+allow postfix_domain self:unix_stream_socket create_stream_socket_perms;
+allow postfix_domain self:unix_stream_socket connectto;
+allow postfix_domain self:fifo_file rw_fifo_file_perms;
+
+allow postfix_master_t postfix_domain:fifo_file { read write };
+allow postfix_master_t postfix_domain:process signal;
+#https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=244456
+allow postfix_domain postfix_master_t:file read;
+allow postfix_domain postfix_etc_t:dir list_dir_perms;
+read_files_pattern(postfix_domain, postfix_etc_t, postfix_etc_t)
+read_lnk_files_pattern(postfix_domain, postfix_etc_t, postfix_etc_t)
+
+allow postfix_domain postfix_exec_t:file { mmap_file_perms lock };
+
+allow postfix_domain postfix_master_t:process sigchld;
+
+allow postfix_domain postfix_spool_t:dir list_dir_perms;
+
+manage_files_pattern(postfix_domain, postfix_var_run_t, postfix_var_run_t)
+files_pid_filetrans(postfix_domain, postfix_var_run_t, file)
+
+kernel_read_network_state(postfix_domain)
+kernel_read_all_sysctls(postfix_domain)
+
+dev_read_sysfs(postfix_domain)
+dev_read_rand(postfix_domain)
+dev_read_urand(postfix_domain)
+
+fs_search_auto_mountpoints(postfix_domain)
+fs_getattr_all_fs(postfix_domain)
+fs_rw_anon_inodefs_files(postfix_domain)
+
+term_dontaudit_use_console(postfix_domain)
+
+corecmd_exec_shell(postfix_domain)
+corecmd_getattr_all_executables(postfix_domain)
+
+files_read_etc_runtime_files(postfix_domain)
+files_read_usr_symlinks(postfix_domain)
+files_search_spool(postfix_domain)
+files_list_tmp(postfix_domain)
+files_search_all_mountpoints(postfix_domain)
+
+init_dontaudit_use_fds(postfix_domain)
+init_sigchld(postfix_domain)
+init_dontaudit_rw_stream_socket(postfix_domain)
+
+# For reading spamassasin
+mta_read_config(postfix_domain)
+mta_read_aliases(postfix_domain)
+
+miscfiles_read_generic_certs(postfix_domain)
+
+userdom_dontaudit_use_unpriv_user_fds(postfix_domain)
+
+optional_policy(`
+	mysql_stream_connect(postfix_domain)
+')
+
+optional_policy(`
+	spamd_stream_connect(postfix_domain)
+	spamassassin_domtrans_client(postfix_domain)
+')
+
+optional_policy(`
+	udev_read_db(postfix_domain)
+')
Index: serefpolicy-contrib-20140730/postgrey.if
===================================================================
--- serefpolicy-contrib-20140730.orig/postgrey.if
+++ serefpolicy-contrib-20140730/postgrey.if
@@ -16,9 +16,9 @@ interface(`postgrey_stream_connect',`
 		type postgrey_var_run_t, postgrey_t, postgrey_spool_t;
 	')
 
+	stream_connect_pattern($1, { postgrey_spool_t postgrey_var_run_t }, { postgrey_spool_t postgrey_var_run_t }, postgrey_t)
 	files_search_pids($1)
 	files_search_spool($1)
-	stream_connect_pattern($1, { postgrey_spool_t postgrey_var_run_t }, { postgrey_spool_t postgrey_var_run_t }, postgrey_t)
 ')
 
 ########################################
@@ -59,14 +59,17 @@ interface(`postgrey_search_spool',`
 #
 interface(`postgrey_admin',`
 	gen_require(`
-		type postgrey_t, postgrey_etc_t, postgrey_spool_t;
-		type postgrey_var_lib_t, postgrey_var_run_t;
-		type postgrey_initrc_exec_t;
+		type postgrey_t, postgrey_etc_t, postgrey_initrc_exec_t;
+		type postgrey_spool_t, postgrey_var_lib_t, postgrey_var_run_t;
 	')
 
-	allow $1 postgrey_t:process { ptrace signal_perms };
+	allow $1 postgrey_t:process signal_perms;
 	ps_process_pattern($1, postgrey_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 postgrey_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, postgrey_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 postgrey_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/postgrey.te
===================================================================
--- serefpolicy-contrib-20140730.orig/postgrey.te
+++ serefpolicy-contrib-20140730/postgrey.te
@@ -16,7 +16,7 @@ type postgrey_initrc_exec_t;
 init_script_file(postgrey_initrc_exec_t)
 
 type postgrey_spool_t;
-files_type(postgrey_spool_t)
+files_spool_file(postgrey_spool_t)
 
 type postgrey_var_lib_t;
 files_type(postgrey_var_lib_t)
@@ -57,7 +57,6 @@ kernel_read_kernel_sysctls(postgrey_t)
 
 corecmd_search_bin(postgrey_t)
 
-corenet_all_recvfrom_unlabeled(postgrey_t)
 corenet_all_recvfrom_netlabel(postgrey_t)
 corenet_tcp_sendrecv_generic_if(postgrey_t)
 corenet_tcp_sendrecv_generic_node(postgrey_t)
@@ -72,17 +71,15 @@ dev_read_sysfs(postgrey_t)
 
 domain_use_interactive_fds(postgrey_t)
 
-files_read_etc_files(postgrey_t)
 files_read_etc_runtime_files(postgrey_t)
-files_read_usr_files(postgrey_t)
 files_getattr_tmp_dirs(postgrey_t)
 
 fs_getattr_all_fs(postgrey_t)
 fs_search_auto_mountpoints(postgrey_t)
 
-logging_send_syslog_msg(postgrey_t)
+auth_read_passwd(postgrey_t)
 
-miscfiles_read_localization(postgrey_t)
+logging_send_syslog_msg(postgrey_t)
 
 sysnet_read_config(postgrey_t)
 
Index: serefpolicy-contrib-20140730/ppp.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/ppp.fc
+++ serefpolicy-contrib-20140730/ppp.fc
@@ -1,30 +1,45 @@
-HOME_DIR/\.ppprc	--	gen_context(system_u:object_r:ppp_home_t,s0)
-
-/etc/rc\.d/init\.d/ppp	--	gen_context(system_u:object_r:pppd_initrc_exec_t,s0)
-
-/etc/ppp	-d	gen_context(system_u:object_r:pppd_etc_t,s0)
-/etc/ppp(/.*)?	--	gen_context(system_u:object_r:pppd_etc_rw_t,s0)
-/etc/ppp/peers(/.*)?	gen_context(system_u:object_r:pppd_etc_rw_t,s0)
-/etc/ppp/.*secrets	--	gen_context(system_u:object_r:pppd_secret_t,s0)
-/etc/ppp/resolv\.conf	--	gen_context(system_u:object_r:pppd_etc_rw_t,s0)
-/etc/ppp/(auth|ip(v6|x)?)-(up|down)	--	gen_context(system_u:object_r:pppd_initrc_exec_t,s0)
-
-/sbin/ppp-watch	--	gen_context(system_u:object_r:pppd_exec_t,s0)
-/sbin/pppoe-server	--	gen_context(system_u:object_r:pppd_exec_t,s0)
-
-/usr/sbin/ipppd	--	gen_context(system_u:object_r:pppd_exec_t,s0)
-/usr/sbin/ppp-watch	--	gen_context(system_u:object_r:pppd_exec_t,s0)
-/usr/sbin/pppd	--	gen_context(system_u:object_r:pppd_exec_t,s0)
-/usr/sbin/pppoe-server	--	gen_context(system_u:object_r:pppd_exec_t,s0)
-/usr/sbin/pptp	--	gen_context(system_u:object_r:pptp_exec_t,s0)
+#
+# /etc
+#
+/etc/rc\.d/init\.d/ppp		--	gen_context(system_u:object_r:pppd_initrc_exec_t,s0)
+
+/etc/ppp			-d	gen_context(system_u:object_r:pppd_etc_t,s0)
+/etc/ppp(/.*)?			--	gen_context(system_u:object_r:pppd_etc_rw_t,s0)
+/etc/ppp/peers(/.*)?			gen_context(system_u:object_r:pppd_etc_rw_t,s0)
+/etc/ppp/.*secrets		--	gen_context(system_u:object_r:pppd_secret_t,s0)
+/etc/ppp/resolv\.conf 		--	gen_context(system_u:object_r:pppd_etc_rw_t,s0)
+# Fix /etc/ppp {up,down} family scripts (see man pppd)
+/etc/ppp/(auth|ip(v6|x)?)-(up|down) --	gen_context(system_u:object_r:pppd_initrc_exec_t,s0)
+
+/usr/lib/systemd/system/ppp.*	--	gen_context(system_u:object_r:iptables_unit_file_t,s0)
+
+/root/.ppprc			--	gen_context(system_u:object_r:pppd_etc_t,s0)
+
+#
+# /sbin
+#
+/sbin/pppoe-server      --  gen_context(system_u:object_r:pppd_exec_t,s0)
+/sbin/ppp-watch		--  gen_context(system_u:object_r:pppd_exec_t,s0)
+
+#
+# /usr
+#
+/usr/sbin/ipppd			--	gen_context(system_u:object_r:pppd_exec_t,s0)
+/usr/sbin/ppp-watch		--	gen_context(system_u:object_r:pppd_exec_t,s0)
+/usr/sbin/pppd			--	gen_context(system_u:object_r:pppd_exec_t,s0)
+/usr/sbin/pppoe-server		--	gen_context(system_u:object_r:pppd_exec_t,s0)
+/usr/sbin/pptp 			--	gen_context(system_u:object_r:pptp_exec_t,s0)
+
+#
+# /var
+#
+/var/run/(i)?ppp.*pid[^/]*	--	gen_context(system_u:object_r:pppd_var_run_t,s0)
+/var/run/pppd[0-9]*\.tdb	--	gen_context(system_u:object_r:pppd_var_run_t,s0)
+/var/run/ppp(/.*)?			gen_context(system_u:object_r:pppd_var_run_t,s0)
+# Fix pptp sockets
+/var/run/pptp(/.*)?			gen_context(system_u:object_r:pptp_var_run_t,s0)
 
-/var/lock/ppp(/.*)?	gen_context(system_u:object_r:pppd_lock_t,s0)
+/var/lock/ppp(/.*)?		gen_context(system_u:object_r:pppd_lock_t,s0)
 
 /var/log/ppp-connect-errors.*	--	gen_context(system_u:object_r:pppd_log_t,s0)
-/var/log/ppp/.*	--	gen_context(system_u:object_r:pppd_log_t,s0)
-/var/log/pptp.*	--	gen_context(system_u:object_r:pptp_log_t,s0)
-
-/var/run/(i)?ppp.*pid[^/]*	--	gen_context(system_u:object_r:pppd_var_run_t,s0)
-/var/run/pppd[0-9]*\.tdb	--	gen_context(system_u:object_r:pppd_var_run_t,s0)
-/var/run/ppp(/.*)?	gen_context(system_u:object_r:pppd_var_run_t,s0)
-/var/run/pptp(/.*)?	gen_context(system_u:object_r:pptp_var_run_t,s0)
+/var/log/ppp(/.*)?	gen_context(system_u:object_r:pppd_log_t,s0)
Index: serefpolicy-contrib-20140730/ppp.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ppp.if
+++ serefpolicy-contrib-20140730/ppp.if
@@ -1,110 +1,91 @@
-## <summary>Point to Point Protocol daemon creates links in ppp networks.</summary>
+## <summary>Point to Point Protocol daemon creates links in ppp networks</summary>
 
-########################################
+#######################################
 ## <summary>
-##	Role access for ppp.
+##  Create, read, write, and delete
+##  ppp home files.
 ## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
 ## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
-## </param>
-#
-interface(`ppp_role',`
-	refpolicywarn(`$0($*) has been deprecated')
-')
-
-########################################
-## <summary>
-##	Create, read, write, and delete
-##	ppp home files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
 interface(`ppp_manage_home_files',`
-	gen_require(`
-		type ppp_home_t;
-	')
+    gen_require(`
+        type ppp_home_t;
+    ')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 ppp_home_t:file manage_file_perms;
+    userdom_search_user_home_dirs($1)
+    allow $1 ppp_home_t:file manage_file_perms;
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Read ppp user home content files.
+##  Read ppp user home content files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
 interface(`ppp_read_home_files',`
-	gen_require(`
-		type ppp_home_t;
+    gen_require(`
+        type ppp_home_t;
 
-	')
+    ')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 ppp_home_t:file read_file_perms;
+    userdom_search_user_home_dirs($1)
+    allow $1 ppp_home_t:file read_file_perms;
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Relabel ppp home files.
+##  Relabel ppp home files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
 interface(`ppp_relabel_home_files',`
-	gen_require(`
-		type ppp_home_t;
-	')
+    gen_require(`
+        type ppp_home_t;
+    ')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 ppp_home_t:file relabel_file_perms;
+    userdom_search_user_home_dirs($1)
+    allow $1 ppp_home_t:file relabel_file_perms;
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Create objects in user home
-##	directories with the ppp home type.
+##  Create objects in user home
+##  directories with the ppp home type.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 ## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
+##  <summary>
+##  Class of the object being created.
+##  </summary>
 ## </param>
 ## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
+##  <summary>
+##  The name of the object being created.
+##  </summary>
 ## </param>
 #
 interface(`ppp_home_filetrans_ppp_home',`
-	gen_require(`
-		type ppp_home_t;
-	')
+    gen_require(`
+        type ppp_home_t;
+    ')
 
-	userdom_user_home_dir_filetrans($1, ppp_home_t, $2, $3)
+    userdom_user_home_dir_filetrans($1, ppp_home_t, $2, $3)
 ')
 
 ########################################
@@ -128,7 +109,7 @@ interface(`ppp_use_fds',`
 ########################################
 ## <summary>
 ##	Do not audit attempts to inherit
-##	and use ppp file discriptors.
+##	and use PPP file discriptors.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -146,7 +127,7 @@ interface(`ppp_dontaudit_use_fds',`
 
 ########################################
 ## <summary>
-##	Send child terminated signals to ppp.
+##	Send a SIGCHLD signal to PPP.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -165,7 +146,7 @@ interface(`ppp_sigchld',`
 
 ########################################
 ## <summary>
-##	Send kill signals to ppp.
+##	Send ppp a kill signal
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -173,7 +154,6 @@ interface(`ppp_sigchld',`
 ##	</summary>
 ## </param>
 #
-#
 interface(`ppp_kill',`
 	gen_require(`
 		type pppd_t;
@@ -184,7 +164,7 @@ interface(`ppp_kill',`
 
 ########################################
 ## <summary>
-##	Send generic signals to ppp.
+##	Send a generic signal to PPP.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -202,7 +182,7 @@ interface(`ppp_signal',`
 
 ########################################
 ## <summary>
-##	Send null signals to ppp.
+##	Send a generic signull to PPP.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -220,7 +200,7 @@ interface(`ppp_signull',`
 
 ########################################
 ## <summary>
-##	 Execute pppd in the pppd domain.
+##	 Execute domain in the ppp domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -239,8 +219,7 @@ interface(`ppp_domtrans',`
 
 ########################################
 ## <summary>
-##	Conditionally execute pppd on
-##	behalf of a user or staff type.
+##	 Conditionally execute ppp daemon on behalf of a user or staff type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -249,7 +228,7 @@ interface(`ppp_domtrans',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to allow the ppp domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -268,8 +247,7 @@ interface(`ppp_run_cond',`
 
 ########################################
 ## <summary>
-##	Unconditionally execute ppp daemon
-##	on behalf of a user or staff type.
+##	 Unconditionally execute ppp daemon on behalf of a user or staff type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -278,7 +256,7 @@ interface(`ppp_run_cond',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to allow the ppp domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -294,7 +272,7 @@ interface(`ppp_run',`
 
 ########################################
 ## <summary>
-##	 Execute domain in the caller domain.
+##	 Execute domain in the ppp caller.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -326,13 +304,13 @@ interface(`ppp_read_config',`
 		type pppd_etc_t;
 	')
 
-	files_search_etc($1)
 	read_files_pattern($1, pppd_etc_t, pppd_etc_t)
+	files_search_etc($1)
 ')
 
 ########################################
 ## <summary>
-##	Read ppp writable configuration content.
+##	Read PPP-writable configuration files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -345,15 +323,14 @@ interface(`ppp_read_rw_config',`
 		type pppd_etc_t, pppd_etc_rw_t;
 	')
 
-	files_search_etc($1)
-	allow $1 { pppd_etc_t pppd_etc_rw_t }:dir list_dir_perms;
+	allow $1 pppd_etc_t:dir list_dir_perms;
 	allow $1 pppd_etc_rw_t:file read_file_perms;
-	allow $1 { pppd_etc_t pppd_etc_rw_t }:lnk_file read_lnk_file_perms;
+	files_search_etc($1)
 ')
 
 ########################################
 ## <summary>
-##	Read ppp secret files.
+##	Read PPP secrets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -366,15 +343,14 @@ interface(`ppp_read_secrets',`
 		type pppd_etc_t, pppd_secret_t;
 	')
 
-	files_search_etc($1)
 	allow $1 pppd_etc_t:dir list_dir_perms;
 	allow $1 pppd_secret_t:file read_file_perms;
-	allow $1 pppd_etc_t:lnk_file read_lnk_file_perms;
+	files_search_etc($1)
 ')
 
 ########################################
 ## <summary>
-##	Read ppp pid files.
+##	Read PPP pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -388,13 +364,12 @@ interface(`ppp_read_pid_files',`
 	')
 
 	files_search_pids($1)
-	allow $1 pppd_var_run_t:file read_file_perms;
+	read_files_pattern($1, pppd_var_run_t, pppd_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	ppp pid files.
+##	Create, read, write, and delete PPP pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -408,42 +383,30 @@ interface(`ppp_manage_pid_files',`
 	')
 
 	files_search_pids($1)
-	allow $1 pppd_var_run_t:file manage_file_perms;
+	manage_files_pattern($1, pppd_var_run_t, pppd_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Create specified pppd pid objects
-##	with a type transition.
+##	Create, read, write, and delete PPP pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
 interface(`ppp_pid_filetrans',`
 	gen_require(`
 		type pppd_var_run_t;
 	')
 
-	files_pid_filetrans($1, pppd_var_run_t, $2, $3)
+	files_pid_filetrans($1, pppd_var_run_t, file)
 ')
 
 ########################################
 ## <summary>
-##	Execute pppd init script in
-##	the initrc domain.
+##	Execute ppp server in the ntpd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -461,31 +424,62 @@ interface(`ppp_initrc_domtrans',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an ppp environment.
+##	Execute pppd server in the pppd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`ppp_systemctl',`
+	gen_require(`
+		type pppd_unit_file_t;
+		type pppd_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 pppd_unit_file_t:file read_file_perms;
+	allow $1 pppd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, pppd_t)
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an ppp environment
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
+## <param name="role">
+##      <summary>
+##      Role allowed access.
+##      </summary>
+## </param>
 ## <rolecap/>
 #
 interface(`ppp_admin',`
 	gen_require(`
 		type pppd_t, pppd_tmp_t, pppd_log_t, pppd_lock_t;
-		type pppd_etc_t, pppd_secret_t, pppd_etc_rw_t;
-		type pppd_var_run_t, pppd_initrc_exec_t;
+		type pppd_etc_t, pppd_secret_t, pppd_var_run_t;
 		type pptp_t, pptp_log_t, pptp_var_run_t;
+		type pppd_initrc_exec_t, pppd_etc_rw_t;
+		type pppd_unit_file_t;
+	')
+
+	allow $1 pppd_t:process signal_perms;
+	ps_process_pattern($1, pppd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 pppd_t:process ptrace;
+		allow $1 pptp_t:process ptrace;
 	')
 
-	allow $1 { pptp_t pppd_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { pptp_t pppd_t })
+	allow $1 pptp_t:process signal_perms;
+	ps_process_pattern($1, pptp_t)
 
 	ppp_initrc_domtrans($1)
 	domain_system_change_exemption($1)
@@ -496,14 +490,26 @@ interface(`ppp_admin',`
 	admin_pattern($1, pppd_tmp_t)
 
 	logging_list_logs($1)
-	admin_pattern($1, { pptp_log_t pppd_log_t })
+	admin_pattern($1, pppd_log_t)
 
 	files_list_locks($1)
 	admin_pattern($1, pppd_lock_t)
 
 	files_list_etc($1)
-	admin_pattern($1, { pppd_etc_rw_t pppd_secret_t pppd_etc_t })
+	admin_pattern($1, pppd_etc_t)
+
+	admin_pattern($1, pppd_etc_rw_t)
+
+	admin_pattern($1, pppd_secret_t)
 
 	files_list_pids($1)
-	admin_pattern($1, { pptp_var_run_t pppd_var_run_t })
+	admin_pattern($1, pppd_var_run_t)
+
+	admin_pattern($1, pptp_log_t)
+
+	admin_pattern($1, pptp_var_run_t)
+
+	ppp_systemctl($1)
+	admin_pattern($1, pppd_unit_file_t)
+	allow $1 pppd_unit_file_t:service all_service_perms;
 ')
